﻿// ** AUTO-UI IMPORT STATEMENTS **
// ** END AUTO-UI IMPORT STATEMENTS **
import mx.events.EventDispatcher;

class com.gskinner.controls.SimpleTab extends MovieClip {
// Constants:
	public static var CLASS_REF = com.gskinner.controls.SimpleTab;
	public static var LINKAGE_ID:String = "SimpleTab";
// Public Properties:
	public var index:Number;
	public var depth:Number;
// Private Properties:
	private var __width:Number;
	private var height:Number = 19;
	private var __enabled:Boolean = true;
	private var _label:String;
	private var _selected:Boolean = false;
// UI Elements:
	private var labelFld:TextField;
	
	private var dispatchEvent:Function;
	public var addEventListener:Function;
	public var removeEventListener:Function;

// ** AUTO-UI ELEMENTS **
// ** END AUTO-UI ELEMENTS **

// Initialization:
	private function SimpleTab() { 
		EventDispatcher.initialize(this);
		configUI();
	}
	private function onLoad():Void {}

// Public Methods:
	public function get width():Number { return __width; }
	public function set width(p_width:Number):Void { __width = p_width; }
	public function get enabled():Boolean { return __enabled; }
	public function set enabled(p_enabled:Boolean):Void {
		if (__enabled == p_enabled) { return; }
		__enabled = p_enabled;
		dispatchEvent({type:"change"});
		draw();
	}
	public function get label():String { return _label; }
	public function set label(p_label:String):Void {
		_label = p_label;
		labelFld.textColor = (enabled) ? 0x000000 : 0x999999;
		dispatchEvent({type:"change"});
	}
	public function get selected():Boolean { return _selected; }
	public function set selected(p_selected:Boolean):Void {
		_selected = p_selected;
		draw();
	}
// Semi-Private Methods:
// Private Methods:
	private function configUI():Void {
		labelFld._width = labelFld.textWidth + 5;
		labelFld._height = labelFld.textHeight + 2;
		width = Math.ceil(labelFld._x + labelFld._width + 5);
		draw();
	}
	private function draw():Void {
		clear();
		if (enabled) {
			beginFill(selected?0xFFFFFF:0xEEEEEE);
			labelFld.textColor = 0x000000;
		} else {
			beginFill(0xDDDDDD);
			labelFld.textColor = 0x999999;
		}
		lineStyle(0, 0x999999);
		moveTo(0,height);
		lineTo(0,0);
		lineTo(width-4, 0);
		lineTo(width+8, height);
		lineStyle(0,0xFFFFFF)
		endFill();
	}
	
	private function onRelease():Void {
		if (!enabled) { return; }
		dispatchEvent({type:"click"});
	}

}