﻿// ** AUTO-UI IMPORT STATEMENTS **
// ** END AUTO-UI IMPORT STATEMENTS **

import mx.utils.Delegate;
import mx.events.EventDispatcher;

[Event("change")]
[IconFile("tab.png")]

class com.gskinner.controls.SimpleTabBox extends MovieClip {
// Constants:
	public static var CLASS_REF = com.gskinner.controls.SimpleTabBox;
	public static var LINKAGE_ID:String = "SimpleTabBox";
	private static var SELECTED_DEPTH:Number = 201;
// Public Properties:
	public var destroyChildAt:Function;
// Private Properties:
	private var tabList:Array;
	private var clipList:Array;
	private var nextDepth:Number = 300;
	private var model:Array;
	private var _selected:Number = -1;
	private var _tabLinkage:String = "SimpleTab";
	private var _bgLinkage:String = "SimpleBackground";
	private var loaded:Boolean = false;
	private var __width:Number;
	private var __height:Number;
	private var _enabled:Boolean = true;
	private var currentTab:MovieClip;
	private var doLaterIntervalID:Number;
	private var doLaterMethods:Object;
	private var _tmpModel:Array;

	private var dispatchEvent:Function;
	public var addEventListener:Function;
	public var removeEventListener:Function;

// UI Elements:
	private var bg:MovieClip;
	private var sampleTab:MovieClip;
	private var mask:MovieClip;
	private var cover:MovieClip;

// ** AUTO-UI ELEMENTS **
// ** END AUTO-UI ELEMENTS **

// Initialization:
	private function SimpleTabBox() {
		EventDispatcher.initialize(this);
		sampleTab = attachMovie(tabLinkage, "sampleTab", 1000, {label:"yS",_visible:false});
		doLaterMethods = {};
		model = [];
		clipList = [];
	}
	private function onLoad():Void {
		init();
	}
	private function init():Void {
		// Create Mask
		mask = createEmptyMovieClip("mask", 400);
		mask._visible = false;
		mask.beginFill(0xFF9900);
		mask.moveTo(0,0);
		mask.lineTo(100,0);
		mask.lineTo(100, 100);
		mask.lineTo(0, 100);
		mask.lineTo(0,0);
		mask.endFill();
		//
		// Create Cover
		cover = createEmptyMovieClip("cover", 401);
		cover._visible = false;
		cover.beginFill(0xFFFFFF, 70);
		cover.moveTo(0,0);
		cover.lineTo(100,0);
		cover.lineTo(100,100);
		cover.lineTo(0,100);
		cover.lineTo(0,0);
		cover.endFill();
		cover.onRelease = function() {}
		cover.useHandCursor = false;
		//
		configUI();
	}

// Public Methods:
	public function createChild(p_linkage:String, p_instance:String, p_props:Object, p_initObj:Object):MovieClip {
		return createChildAt(length, p_linkage, p_instance, p_props, p_initObj);
	}
	public function createChildAt(p_index:Number, p_linkage:String, p_instance:String, p_props:Object, p_initObj:Object):MovieClip {
		nextDepth++;
		p_index = Math.max(0, Math.min(length, p_index));
		if (p_instance == undefined) { p_instance = "instance" + nextDepth; }
		model.splice(p_index,0, {label:p_props.label, linkage:p_linkage});

		if (! loaded) { return; }	
		var c:MovieClip = attachMovie(p_linkage, p_instance, nextDepth, {_visible:false, _x:3, _y:sampleTab.height+3});
		if (c == undefined) {
			c = createEmptyMovieClip(p_instance, nextDepth);
			c._x = 3;
			c._y = sampleTab._y +3;
			c._visible = false;
		}
		clipList.splice(p_index, 1, c);
		doLater("draw");
		return c;
	}
	public function getChildAt(p_index:Number):MovieClip {
		return clipList[p_index];
	}
	public function getTabAt(p_index:Number):MovieClip {
		if (!loaded) { return model[p_index]; }
		return tabList[p_index];
	}
	public function getInstance(p_name:String):MovieClip {
		var l:Number = length;
		for (var i:Number=0; i<l; i++) {
			if (clipList[i]._name == p_name) { return clipList[i]; }
		}
		return null;
	}
	public function getIndex(p_instance):Number { // instance is instance name or clip reference
		var l:Number = length;
		for (var i:Number=0; i<l; i++) {
			if (p_instance instanceof String) {
				if (clipList[i]._name == p_instance) { return i; }
			} else if (p_instance instanceof MovieClip) {
				if (clipList[i] == p_instance) { return i; }
			}
		}
		return -1;
	}
	public function removeInstance(p_instance):Boolean {
		
		var index:Number = getIndex(p_instance);
		return removeChildAt(index);
	}
	public function removeChildAt(p_index:Number):Boolean {
		if (getChildAt(p_index) == undefined) { return false; }
		clipList[p_index].removeMovieClip();
		clipList.splice(p_index, 1);
		tabList[p_index].removeMovieClip();
		tabList.splice(p_index, 1);
		model.splice(p_index, 1);
		if (selectedIndex >= p_index) { selectedIndex--; }
		doLater("draw");
		return true;
	}
	public function removeAll():Void {
		dataProvider = [];
		while(tabList.length) { tabList.pop().removeMovieClip(); }
		while(clipList.length) { clipList.pop().removeMovieClip(); }
		model = [];
		selectedIndex = -1;
		doLater("draw");
	}
	public function setSize(p_width:Number, p_height:Number):Void {
		__width = p_width;
		__height = p_height;
		doLater("draw");
	}
	public function move(p_x:Number, p_y:Number):Void {
		_x = p_x;
		_y = p_y;
	}

// Getter / Setters
	public function get dataProvider():Array { return model; }
	public function set dataProvider(p_dp:Array):Void {
		_tmpModel = p_dp;
		while(clipList.length) { clipList.pop().removeMovieClip(); }
		clipList = [];

		var nextDepth:Number = 300;
		var l:Number = _tmpModel.length;
		for (var i:Number=0; i<l; i++) {
			createChild(_tmpModel[i].linkage, _tmpModel[i].name, {label:_tmpModel[i].label});
		}
		doLater("draw");
	}
	public function get length():Number { return model.length; }
	public function get numChildren():Number { return model.length; }
	public function get selectedIndex():Number { return (_selected == -1) ? 0 : _selected; }
	public function set selectedIndex(p_index:Number):Void {
		if (_selected == p_index) { return; }
		_selected = p_index;
		doLater("drawTabs");
	}
	public function get tabLinkage():String { return _tabLinkage; }
	public function set tabLinkage(p_linkage:String):Void {
		_tabLinkage = p_linkage;
		sampleTab = attachMovie(tabLinkage, "sampleTab", 1000, {label:"yS", _visible:false});
		doLater("draw");
	}
	public function get background():String { return _bgLinkage; }
	public function set background(p_linkage:String):Void {
		_bgLinkage = p_linkage;
		bg.removeMovieClip();
		bg = attachMovie(_bgLinkage, "bg", 200, {_y:sampleTab.height});
		doLater("draw");
	}
	public function get width():Number { return __width; }
	public function get height():Number { return __height; }
	public function get enabled():Boolean { return _enabled; }
	public function set enabled(p_enabled:Boolean):Void {
		_enabled = p_enabled;
		var l:Number = length;
		for (var i:Number=0; i<l; i++) {
			if (loaded) {
				getTabAt(i).enabled = enabled;
			}
			model[i].enabled = enabled;
		}
		var index:Number = getTabIndex(currentTab);
		clipList[index]._visible = enabled;
	}


// Semi-Private Methods:
	function click(p_evtObj:Object):Void {
		// Find Index
		var index:Number = getTabIndex(p_evtObj.target);
		if (index == -1) { return; }
		dispatchEvent({type:"click"});
		selectedIndex = index;
	}
	function change(p_evtObj:Object):Void {
		var index = getTabIndex(p_evtObj.target);
		dataProvider[index].enabled = p_evtObj.target.enabled;
		dataProvider[index].label = p_evtObj.target.label;
		doLater("drawTabs");
	}

// Private Methods:
	private function configUI():Void {
		model = [];
		var w:Number = _width;
		var h:Number = _height;
		_xscale = _yscale = 100;
		if (width == undefined) { setSize(w, h); }
		destroyChildAt = removeChildAt;
		loaded = true;
		//
		background = _bgLinkage;
		dataProvider = _tmpModel;
	}
	private function draw():Void {
		if (!loaded) { return; }
		//
		// Scale the BG.  Allow both setSize and w/h scaling.
		if (bg.setSize != undefined) {
			bg.setSize(width, height - bg._y);
		} else {
			bg._width = width;
			bg._height = height - bg._y;
		}
		//
		// Move and scale the mask and cover.
		mask._y = cover._y = sampleTab._height + 3;
		mask._x = cover._x = 3;
		var w:Number = width-6;
		var h:Number = height - mask._y - 3;
		mask._width = cover._width = w;
		mask._height = cover._height = h;
		//
		// Scale the content clips.  Use setsize, otherwise mask.
		for (var i:Number=0; i<length; i++) {
			if (clipList[i].setSize == undefined) { continue; }
			clipList[i].setSize(width-6, height-mask._y-3);
		}
		//
		drawTabs();
	}
	private function drawTabs():Void {
		if (! loaded) { return; }
		while (tabList.length) { tabList.pop().removeMovieClip(); }
		tabList = [];
		var t:MovieClip;

		var l:Number = length;
		for (var i:Number=0; i<l; i++) {
			var d:Number = 199 - i;
			var x:Number = (t == undefined) ? 2 : t._x + ((t.width==undefined)?t._width:t.width);
			t = attachMovie(tabLinkage, "tab" + i, d, {index:i, label:model[i].label, _x:x, __enabled:model[i].enabled != false, depth:d});
			if (t._x + t._width > width) {
				t.removeMovieClip();
				break;
			}
			t.enabled = _enabled;
			t.addEventListener("click", this);
			t.addEventListener("change", this);
			tabList.push(t);
		}
		selectTab(selectedIndex);
	}
	private function getTabIndex(p_tab:MovieClip):Number {
		var l:Number = length;
		for (var i:Number=0; i<l; i++) {
			if (tabList[i] == p_tab) { return i; }
		}
		return -1;
	}
	private function selectTab(p_index:Number):Void {
		var oldIndex:Number = getTabIndex(currentTab);
		// Swap Clips
		clipList[oldIndex]._visible = false;
		currentTab.swapDepths(currentTab.depth);
		currentTab.selected = false;
		currentTab.useHandCursor = true;

		currentTab = tabList[p_index];
		var clip:MovieClip = clipList[p_index];
		clip._visible = true;
		cover._visible = (model[p_index].enabled == false || enabled == false);
		clip.setMask(mask);
		// Swap Tabs
		currentTab.swapDepths(SELECTED_DEPTH);
		currentTab.selected = true;
		currentTab.useHandCursor = false;
	}

// Invalidation stuff
	private function doLater(p_fn:String):Void {
		doLaterMethods[p_fn] = true;
		if (!doLaterIntervalID) { doLaterIntervalID = setInterval(this,"doLaterDispatcher",1); }
	}

	private function doLaterDispatcher():Void {
		for (var method:String in doLaterMethods) {
			this[method]();
			delete doLaterMethods[method];
		}
		clearInterval(doLaterIntervalID);
		delete doLaterIntervalID;
	}

}